1 # Library of functions shared by all tests scripts, included by
4 # Copyright (c) 2005 Junio C Hamano
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see http://www.gnu.org/licenses/ .
19 # The semantics of the editor variables are that of invoking
20 # sh -c "$EDITOR \"$@\"" files ...
22 # If our trash directory contains shell metacharacters, they will be
23 # interpreted if we just set $EDITOR directly, so do a little dance with
24 # environment variables to work around this.
26 # In particular, quoting isn't enough, as the path may contain the same quote
31 EDITOR
='"$FAKE_EDITOR"'
35 test_set_index_version
() {
36 GIT_INDEX_VERSION
="$1"
37 export GIT_INDEX_VERSION
40 test_decode_color
() {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
45 if (n == 30) return "BLACK";
46 if (n == 31) return "RED";
47 if (n == 32) return "GREEN";
48 if (n == 33) return "YELLOW";
49 if (n == 34) return "BLUE";
50 if (n == 35) return "MAGENTA";
51 if (n == 36) return "CYAN";
52 if (n == 37) return "WHITE";
53 if (n == 40) return "BLACK";
54 if (n == 41) return "BRED";
55 if (n == 42) return "BGREEN";
56 if (n == 43) return "BYELLOW";
57 if (n == 44) return "BBLUE";
58 if (n == 45) return "BMAGENTA";
59 if (n == 46) return "BCYAN";
60 if (n == 47) return "BWHITE";
63 while (match($0, /\033\[[0-9;]*m/) != 0) {
64 printf "%s<", substr($0, 1, RSTART-1);
65 codes = substr($0, RSTART+2, RLENGTH-3);
66 if (length(codes) == 0)
69 n = split(codes, ary, ";");
71 for (i = 1; i <= n; i++) {
72 printf "%s%s", sep, name(ary[i]);
77 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
85 perl
-pe 'y/\012/\000/'
109 sed -e 's/$/Q/' |
tr Q
'\015'
113 tr '\015' Q |
sed -e 's/Q$//'
116 # In some bourne shell implementations, the "unset" builtin returns
117 # nonzero status when a variable to be unset was not set in the first
120 # Use sane_unset when that should not be considered an error.
128 if test -z "${test_tick+set}"
132 test_tick
=$
(($test_tick + 60))
134 GIT_COMMITTER_DATE
="$test_tick -0700"
135 GIT_AUTHOR_DATE
="$test_tick -0700"
136 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
139 # Stop execution and start a shell. This is useful for debugging tests and
140 # only makes sense together with "-v".
142 # Be sure to remove all invocations of this command before submitting.
145 if test "$verbose" = t
; then
146 "$SHELL_PATH" <&6 >&3 2>&4
148 error
>&5 "test_pause requires --verbose"
152 # Wrap git in gdb. Adding this to a command can make it easier to
153 # understand what is going on in a failing test.
155 # Example: "debug git checkout master".
160 # Call test_commit with the arguments
161 # [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
163 # This will commit a file with the given contents and the given commit
164 # message, and tag the resulting commit with the given tag name.
166 # <file>, <contents>, and <tag> all default to <message>.
168 # If the first argument is "-C", the second argument is used as a path for
169 # the git invocations.
194 indir
=${indir:+"$indir"/} &&
196 echo "${3-$1}" > "$indir$file" &&
197 git
${indir:+ -C "$indir"} add
"$file" &&
202 git
${indir:+ -C "$indir"} commit
$signoff -m "$1" &&
203 git
${indir:+ -C "$indir"} tag
"${4:-$1}"
206 # Call test_merge with the arguments "<message> <commit>", where <commit>
207 # can be a tag pointing to the commit-to-merge.
211 git merge
-m "$1" "$2" &&
215 # This function helps systems where core.filemode=false is set.
216 # Use it instead of plain 'chmod +x' to set or unset the executable bit
217 # of a file in the working directory and add it to the index.
221 git update-index
--add "--chmod=$@"
224 # Unset a configuration variable, but don't fail if it doesn't exist.
233 git
${config_dir:+-C "$config_dir"} config
--unset-all "$@"
235 case "$config_status" in
236 5) # ok, nothing to unset
240 return $config_status
243 # Set git config, automatically unsetting it after the test is over.
252 test_when_finished
"test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
253 git
${config_dir:+-C "$config_dir"} config
"$@"
256 test_config_global
() {
257 test_when_finished
"test_unconfig --global '$1'" &&
258 git config
--global "$@"
263 echo "#!${2-"$SHELL_PATH"}" &&
269 # Use test_set_prereq to tell that a particular prerequisite is available.
270 # The prerequisite can later be checked for in two ways:
272 # - Explicitly using test_have_prereq.
274 # - Implicitly by specifying the prerequisite tag in the calls to
275 # test_expect_{success,failure,code}.
277 # The single parameter is the prerequisite tag (a simple word, in all
278 # capital letters by convention).
281 satisfied_prereq
="$satisfied_prereq$1 "
284 lazily_testable_prereq
= lazily_tested_prereq
=
286 # Usage: test_lazy_prereq PREREQ 'script'
287 test_lazy_prereq
() {
288 lazily_testable_prereq
="$lazily_testable_prereq$1 "
289 eval test_prereq_lazily_
$1=\
$2
292 test_run_lazy_prereq_
() {
294 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
296 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
298 say
>&3 "checking prerequisite: $1"
302 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
303 if test "$eval_ret" = 0; then
304 say
>&3 "prerequisite $1 ok"
306 say
>&3 "prerequisite $1 not satisfied"
311 test_have_prereq
() {
312 # prerequisites can be concatenated with ','
324 case "$prerequisite" in
327 prerequisite
=${prerequisite#!}
333 case " $lazily_tested_prereq " in
337 case " $lazily_testable_prereq " in
339 eval "script=\$test_prereq_lazily_$prerequisite" &&
340 if test_run_lazy_prereq_
"$prerequisite" "$script"
342 test_set_prereq
$prerequisite
344 lazily_tested_prereq
="$lazily_tested_prereq$prerequisite "
349 total_prereq
=$
(($total_prereq + 1))
350 case "$satisfied_prereq" in
352 satisfied_this_prereq
=t
355 satisfied_this_prereq
=
358 case "$satisfied_this_prereq,$negative_prereq" in
360 ok_prereq
=$
(($ok_prereq + 1))
363 # Keep a list of missing prerequisites; restore
364 # the negative marker if necessary.
365 prerequisite
=${negative_prereq:+!}$prerequisite
366 if test -z "$missing_prereq"
368 missing_prereq
=$prerequisite
370 missing_prereq
="$prerequisite,$missing_prereq"
375 test $total_prereq = $ok_prereq
378 test_declared_prereq
() {
379 case ",$test_prereq," in
387 test_verify_prereq
() {
388 test -z "$test_prereq" ||
389 expr >/dev
/null
"$test_prereq" : '[A-Z0-9_,!]*$' ||
390 error
"bug in the test script: '$test_prereq' does not look like a prereq"
393 test_expect_failure
() {
395 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
397 error
"bug in the test script: not 2 or 3 parameters to test-expect-failure"
402 say
>&3 "checking known breakage: $2"
403 if test_run_
"$2" expecting_failure
405 test_known_broken_ok_
"$1"
407 test_known_broken_failure_
"$1"
413 test_expect_success
() {
415 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
417 error
"bug in the test script: not 2 or 3 parameters to test-expect-success"
422 say
>&3 "expecting success: $2"
433 # test_external runs external test scripts that provide continuous
434 # test output about their progress, and succeeds/fails on
435 # zero/non-zero exit code. It outputs the test output on stdout even
436 # in non-verbose mode, and announces the external script with "# run
437 # <n>: ..." before running it. When providing relative paths, keep in
438 # mind that all scripts run in "trash directory".
439 # Usage: test_external description command arguments...
440 # Example: test_external 'Perl API' perl ../path/to/test.pl
442 test "$#" = 4 && { test_prereq
=$1; shift; } || test_prereq
=
444 error
>&5 "bug in the test script: not 3 or 4 parameters to test_external"
449 if ! test_skip
"$descr" "$@"
451 # Announce the script to reduce confusion about the
452 # test output that follows.
453 say_color
"" "# run $test_count: $descr ($*)"
454 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
455 # to be able to use them in script
456 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
457 # Run command; redirect its stderr to &4 as in
458 # test_run_, but keep its stdout on our stdout even in
463 if test $test_external_has_tap -eq 0; then
466 say_color
"" "# test_external test $descr was ok"
467 test_success
=$
(($test_success + 1))
470 if test $test_external_has_tap -eq 0; then
471 test_failure_
"$descr" "$@"
473 say_color error
"# test_external test $descr failed: $@"
474 test_failure
=$
(($test_failure + 1))
480 # Like test_external, but in addition tests that the command generated
481 # no output on stderr.
482 test_external_without_stderr
() {
483 # The temporary file has no (and must have no) security
486 stderr
="$tmp/git-external-stderr.$$.tmp"
487 test_external
"$@" 4> "$stderr"
488 test -f "$stderr" || error
"Internal error: $stderr disappeared."
489 descr
="no stderr: $1"
491 say
>&3 "# expecting no stderr from previous command"
492 if test ! -s "$stderr"
496 if test $test_external_has_tap -eq 0; then
499 say_color
"" "# test_external_without_stderr test $descr was ok"
500 test_success
=$
(($test_success + 1))
503 if test "$verbose" = t
505 output
=$
(echo; echo "# Stderr is:"; cat "$stderr")
509 # rm first in case test_failure exits.
511 if test $test_external_has_tap -eq 0; then
512 test_failure_
"$descr" "$@" "$output"
514 say_color error
"# test_external_without_stderr test $descr failed: $@: $output"
515 test_failure
=$
(($test_failure + 1))
520 # debugging-friendly alternatives to "test [-f|-d|-e]"
521 # The commands test the existence or non-existence of $1. $2 can be
522 # given to provide a more precise diagnosis.
523 test_path_is_file
() {
526 echo "File $1 doesn't exist. $2"
531 test_path_is_dir
() {
534 echo "Directory $1 doesn't exist. $2"
539 # Check if the directory exists and is empty as expected, barf otherwise.
540 test_dir_is_empty
() {
541 test_path_is_dir
"$1" &&
542 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
544 echo "Directory '$1' is not empty, it contains:"
550 test_path_is_missing
() {
563 # test_line_count checks that a file has the number of lines it
564 # ought to. For example:
566 # test_expect_success 'produce exactly one line of output' '
567 # do something >output &&
568 # test_line_count = 1 output
571 # is like "test $(wc -l <output) = 1" except that it passes the
572 # output through when the number of lines is wrong.
577 error
"bug in the test script: not 3 parameters to test_line_count"
578 elif ! test $
(wc -l <"$3") "$1" "$2"
580 echo "test_line_count: line count for $3 !$1 $2"
586 # Returns success if a comma separated string of keywords ($1) contains a
587 # given keyword ($2).
589 # `list_contains "foo,bar" bar` returns 0
590 # `list_contains "foo" bar` returns 1
601 # This is not among top-level (test_expect_success | test_expect_failure)
602 # but is a prefix that can be used in the test script, like:
604 # test_expect_success 'complain and die' '
606 # do something else &&
607 # test_must_fail git checkout ../outerspace
610 # Writing this as "! git checkout ../outerspace" is wrong, because
611 # the failure could be due to a segv. We want a controlled failure.
625 if test $exit_code -eq 0 && ! list_contains
"$_test_ok" success
627 echo >&2 "test_must_fail: command succeeded: $*"
629 elif test_match_signal
13 $exit_code && list_contains
"$_test_ok" sigpipe
632 elif test $exit_code -gt 129 && test $exit_code -le 192
634 echo >&2 "test_must_fail: died by signal $(($exit_code - 128)): $*"
636 elif test $exit_code -eq 127
638 echo >&2 "test_must_fail: command not found: $*"
640 elif test $exit_code -eq 126
642 echo >&2 "test_must_fail: valgrind error: $*"
648 # Similar to test_must_fail, but tolerates success, too. This is
649 # meant to be used in contexts like:
651 # test_expect_success 'some command works without configuration' '
652 # test_might_fail git config --unset all.configuration &&
656 # Writing "git config --unset all.configuration || :" would be wrong,
657 # because we want to notice if it fails due to segv.
660 test_must_fail ok
=success
"$@"
663 # Similar to test_must_fail and test_might_fail, but check that a
664 # given command exited with a given exit code. Meant to be used as:
666 # test_expect_success 'Merge with d/f conflicts' '
667 # test_expect_code 1 git merge "merge msg" B master
670 test_expect_code
() {
675 if test $exit_code = $want_code
680 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
684 # test_cmp is a helper function to compare actual and expected output.
685 # You can use it like:
687 # test_expect_success 'foo works' '
688 # echo expected >expected &&
690 # test_cmp expected actual
693 # This could be written as either "cmp" or "diff -u", but:
694 # - cmp's output is not nearly as easy to read as diff -u
695 # - not all diff versions understand "-u"
701 # test_cmp_bin - helper to compare binary files
707 # Call any command "$@" but be more verbose about its
708 # failure. This is handy for commands like "test" which do
709 # not output anything when they fail.
712 echo >&2 "command failed: $(git rev-parse --sq-quote "$@
")"
716 # Check if the file expected to be empty is indeed empty, and barfs
719 test_must_be_empty
() {
722 echo "'$1' is not empty, it contains:"
728 # Tests that its two parameters refer to the same revision
730 git rev-parse
--verify "$1" >expect.
rev &&
731 git rev-parse
--verify "$2" >actual.
rev &&
732 test_cmp expect.
rev actual.
rev
735 # Print a sequence of integers in increasing order, either with
736 # two arguments (start and end):
738 # test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
740 # or with one argument (end), in which case it starts counting
747 *) error
"bug in the test script: not 1 or 2 parameters to test_seq" ;;
749 test_seq_counter__
=$1
750 while test "$test_seq_counter__" -le "$2"
752 echo "$test_seq_counter__"
753 test_seq_counter__
=$
(( $test_seq_counter__ + 1 ))
757 # This function can be used to schedule some commands to be run
758 # unconditionally at the end of the test to restore sanity:
760 # test_expect_success 'test core.capslock' '
761 # git config core.capslock true &&
762 # test_when_finished "git config --unset core.capslock" &&
766 # That would be roughly equivalent to
768 # test_expect_success 'test core.capslock' '
769 # git config core.capslock true &&
771 # git config --unset core.capslock
774 # except that the greeting and config --unset must both succeed for
777 # Note that under --immediate mode, no clean-up is done to help diagnose
780 test_when_finished
() {
781 # We cannot detect when we are in a subshell in general, but by
782 # doing so on Bash is better than nothing (the test will
783 # silently pass on other shells).
784 test "${BASH_SUBSHELL-0}" = 0 ||
785 error
"bug in test script: test_when_finished does nothing in a subshell"
787 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
790 # Most tests can use the created repository, but some may need to create more.
791 # Usage: test_create_repo <directory>
792 test_create_repo
() {
794 error
"bug in the test script: not 1 parameter to test-create-repo"
798 cd "$repo" || error
"Cannot setup test environment"
799 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
800 error
"cannot run git init -- have you built things yet?"
801 mv .git
/hooks .git
/hooks-disabled
805 # This function helps on symlink challenged file systems when it is not
806 # important that the file system entry is a symbolic link.
807 # Use test_ln_s_add instead of "ln -s x y && git add y" to add a
808 # symbolic link entry y to the index.
811 if test_have_prereq SYMLINKS
814 git update-index
--add "$2"
816 printf '%s' "$1" >"$2" &&
817 ln_s_obj
=$
(git hash-object
-w "$2") &&
818 git update-index
--add --cacheinfo 120000 $ln_s_obj "$2" &&
819 # pick up stat info from the file
820 git update-index
"$2"
824 # This function writes out its parameters, one per line
825 test_write_lines
() {
830 command "$PERL_PATH" "$@"
833 # Is the value one of the various ways to spell a boolean true/false?
834 test_normalize_bool
() {
835 git
-c magic.variable
="$1" config
--bool magic.variable
2>/dev
/null
838 # Given a variable $1, normalize the value of it to one of "true",
839 # "false", or "auto" and store the result to it.
841 # test_tristate GIT_TEST_HTTPD
843 # A variable set to an empty string is set to 'false'.
844 # A variable set to 'false' or 'auto' keeps its value.
845 # Anything else is set to 'true'.
846 # An unset variable defaults to 'auto'.
848 # The last rule is to allow people to set the variable to an empty
849 # string and export it to decline testing the particular feature
850 # for versions both before and after this change. We used to treat
851 # both unset and empty variable as a signal for "do not test" and
852 # took any non-empty string as "please test".
855 if eval "test x\"\${$1+isset}\" = xisset"
862 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
870 # Exit the test suite, either by skipping all remaining tests or by
871 # exiting with an error. If "$1" is "auto", we then we assume we were
872 # opportunistically trying to set up some tests and we skip. If it is
873 # "true", then we report a failure.
875 # The error/skip message should be given by $2.
877 test_skip_or_die
() {
887 error
"BUG: test tristate is '$1' (real error: $2)"
891 # The following mingw_* functions obey POSIX shell syntax, but are actually
892 # bash scripts, and are meant to be used only with bash on Windows.
894 # A test_cmp function that treats LF and CRLF equal and avoids to fork
895 # diff when possible.
897 # Read text into shell variables and compare them. If the results
898 # are different, use regular diff to report the difference.
899 local test_cmp_a
= test_cmp_b
=
901 # When text came from stdin (one argument is '-') we must feed it
903 local stdin_for_diff
=
905 # Since it is difficult to detect the difference between an
906 # empty input file and a failure to read the files, we go straight
907 # to diff if one of the inputs is empty.
908 if test -s "$1" && test -s "$2"
910 # regular case: both files non-empty
911 mingw_read_file_strip_cr_ test_cmp_a
<"$1"
912 mingw_read_file_strip_cr_ test_cmp_b
<"$2"
913 elif test -s "$1" && test "$2" = -
915 # read 2nd file from stdin
916 mingw_read_file_strip_cr_ test_cmp_a
<"$1"
917 mingw_read_file_strip_cr_ test_cmp_b
918 stdin_for_diff
='<<<"$test_cmp_b"'
919 elif test "$1" = - && test -s "$2"
921 # read 1st file from stdin
922 mingw_read_file_strip_cr_ test_cmp_a
923 mingw_read_file_strip_cr_ test_cmp_b
<"$2"
924 stdin_for_diff
='<<<"$test_cmp_a"'
926 test -n "$test_cmp_a" &&
927 test -n "$test_cmp_b" &&
928 test "$test_cmp_a" = "$test_cmp_b" ||
929 eval "diff -u \"\$@\" $stdin_for_diff"
932 # $1 is the name of the shell variable to fill in
933 mingw_read_file_strip_cr_
() {
934 # Read line-wise using LF as the line separator
935 # and use IFS to strip CR.
939 if IFS
=$
'\r' read -r -d $
'\n' line
944 # we get here at EOF, but also if the last line
945 # was not terminated by LF; in the latter case,
957 # Like "env FOO=BAR some-program", but run inside a subshell, which means
958 # it also works for shell functions (though those functions cannot impact
959 # the environment outside of the test_env invocation).
966 eval "${1%%=*}=\${1#*=}"
967 eval "export ${1%%=*}"
979 # Returns true if the numeric exit code in "$2" represents the expected signal
980 # in "$1". Signals should be given numerically.
981 test_match_signal
() {
982 if test "$2" = "$((128 + $1))"
986 elif test "$2" = "$((256 + $1))"
994 # Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1000 my $nread = sysread(STDIN, $s, $len);
1001 die "cannot read: $!" unless defined($nread);
1008 # run "$@" inside a non-git directory
1015 GIT_CEILING_DIRECTORIES
=$
(pwd) &&
1016 export GIT_CEILING_DIRECTORIES
&&